﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace DataGridSelectionBehavior
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Cell> _cells = new List<Cell>();
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xamDataGrid1_EditModeStarting(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartingEventArgs e)
        {
            foreach (var cell in _cells)
            {
                cell.IsSelected = true;
            }
        }

        private void xamDataGrid1_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            e.Cell.IsSelected = true;
            _cells.Clear();
            foreach (var cell in xamDataGrid1.SelectedItems.Cells)
            {
                _cells.Add(cell);
            }

            Dispatcher.BeginInvoke(new Action(() =>
            {
                xamDataGrid1.ExecuteCommand(DataPresenterCommands.StartEditMode);
            }));
        }
    }
}
